package caisseppe;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.SimpleDateFormat;
import java.util.Date;
import javax.swing.Timer;
import java.io.*;
import java.util.Scanner;
import javax.swing.table.DefaultTableModel;
import java.sql.*;
import java.text.NumberFormat;
import java.text.ParseException;
import java.util.logging.Level;
import java.util.logging.Logger;
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author Utilisateur
 */
public class Caisse extends javax.swing.JFrame {

    /**
     * Creates new form Caisse
     */
    
    public String nombre = "";
    public int limitIngre = 0;
    public int ingre = 0;
    public float prix = 0.0f;
    
    public Caisse(){
        initComponents();
        CurrentDate();
        Boules.setVisible(false);
        ProduitContenu.setVisible(false);
        
    }
    
    void CurrentDate(){
        new Timer(0, new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e){
                Date d = new Date();
                SimpleDateFormat dt = new SimpleDateFormat("dd/MM/yyyy");
                SimpleDateFormat h = new SimpleDateFormat("HH:mm:ss");
                txt_date.setText(dt.format(d)+" "+h.format(d));
            }
        }).start();
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        BarSup = new javax.swing.JPanel();
        txt_date = new javax.swing.JLabel();
        Numerique = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jButton6 = new javax.swing.JButton();
        jButton7 = new javax.swing.JButton();
        jButton8 = new javax.swing.JButton();
        jButton11 = new javax.swing.JButton();
        jButton12 = new javax.swing.JButton();
        jButton13 = new javax.swing.JButton();
        jButton17 = new javax.swing.JButton();
        jButton14 = new javax.swing.JButton();
        ListCommande = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        Option = new javax.swing.JPanel();
        jButton4 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();
        Produit = new javax.swing.JPanel();
        Produit1 = new javax.swing.JButton();
        Produit2 = new javax.swing.JButton();
        ProduitContenu = new javax.swing.JPanel();
        jToggleButton1 = new javax.swing.JToggleButton();
        jToggleButton2 = new javax.swing.JToggleButton();
        jToggleButton3 = new javax.swing.JToggleButton();
        jToggleButton4 = new javax.swing.JToggleButton();
        Boules = new javax.swing.JPanel();
        jToggleButton7 = new javax.swing.JToggleButton();
        jToggleButton8 = new javax.swing.JToggleButton();
        jToggleButton9 = new javax.swing.JToggleButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Caisse");
        setBackground(new java.awt.Color(204, 204, 204));

        BarSup.setBackground(new java.awt.Color(255, 255, 255));

        txt_date.setFont(new java.awt.Font("Bebas Neue Bold", 0, 36)); // NOI18N
        txt_date.setText("Date et heure");

        javax.swing.GroupLayout BarSupLayout = new javax.swing.GroupLayout(BarSup);
        BarSup.setLayout(BarSupLayout);
        BarSupLayout.setHorizontalGroup(
            BarSupLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(BarSupLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(txt_date)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        BarSupLayout.setVerticalGroup(
            BarSupLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(BarSupLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(txt_date)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        Numerique.setBackground(new java.awt.Color(255, 255, 255));

        jButton1.setText("7");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jButton2.setText("8");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jButton3.setText("9");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jButton6.setText("4");
        jButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton6ActionPerformed(evt);
            }
        });

        jButton7.setText("5");
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton7ActionPerformed(evt);
            }
        });

        jButton8.setText("6");
        jButton8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton8ActionPerformed(evt);
            }
        });

        jButton11.setText("1");
        jButton11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton11ActionPerformed(evt);
            }
        });

        jButton12.setText("2");
        jButton12.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton12ActionPerformed(evt);
            }
        });

        jButton13.setText("3");
        jButton13.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton13ActionPerformed(evt);
            }
        });

        jButton17.setText("0");
        jButton17.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton17ActionPerformed(evt);
            }
        });

        jButton14.setText("C");
        jButton14.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton14ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout NumeriqueLayout = new javax.swing.GroupLayout(Numerique);
        Numerique.setLayout(NumeriqueLayout);
        NumeriqueLayout.setHorizontalGroup(
            NumeriqueLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(NumeriqueLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(NumeriqueLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(NumeriqueLayout.createSequentialGroup()
                        .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(NumeriqueLayout.createSequentialGroup()
                        .addComponent(jButton6, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton7, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton8, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(NumeriqueLayout.createSequentialGroup()
                        .addGroup(NumeriqueLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jButton17, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, NumeriqueLayout.createSequentialGroup()
                                .addComponent(jButton11, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jButton12, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(NumeriqueLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jButton13, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jButton14, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        NumeriqueLayout.setVerticalGroup(
            NumeriqueLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(NumeriqueLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(NumeriqueLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(NumeriqueLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton6, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton8, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton7, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(NumeriqueLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton11, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton13, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton12, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(NumeriqueLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton17, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton14, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        ListCommande.setBackground(new java.awt.Color(255, 255, 255));

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Produit", "Nombre", "Prix"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.Byte.class, java.lang.Float.class
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
        });
        jScrollPane1.setViewportView(jTable1);

        javax.swing.GroupLayout ListCommandeLayout = new javax.swing.GroupLayout(ListCommande);
        ListCommande.setLayout(ListCommandeLayout);
        ListCommandeLayout.setHorizontalGroup(
            ListCommandeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(ListCommandeLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1)
                .addContainerGap())
        );
        ListCommandeLayout.setVerticalGroup(
            ListCommandeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(ListCommandeLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        Option.setBackground(new java.awt.Color(255, 255, 255));

        jButton4.setText("Effacer");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        jButton5.setText("Valider");
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout OptionLayout = new javax.swing.GroupLayout(Option);
        Option.setLayout(OptionLayout);
        OptionLayout.setHorizontalGroup(
            OptionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(OptionLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(OptionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jButton4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jButton5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        OptionLayout.setVerticalGroup(
            OptionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(OptionLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jButton4, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton5, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(19, Short.MAX_VALUE))
        );

        Produit.setBackground(new java.awt.Color(255, 255, 255));

        Produit1.setText("Glace");
        Produit1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Produit1ActionPerformed(evt);
            }
        });

        Produit2.setText("Milk-Shake");
        Produit2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Produit2ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout ProduitLayout = new javax.swing.GroupLayout(Produit);
        Produit.setLayout(ProduitLayout);
        ProduitLayout.setHorizontalGroup(
            ProduitLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(ProduitLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(Produit1, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(Produit2, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(106, Short.MAX_VALUE))
        );

        ProduitLayout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {Produit1, Produit2});

        ProduitLayout.setVerticalGroup(
            ProduitLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(ProduitLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(ProduitLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(Produit1, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(Produit2, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(92, Short.MAX_VALUE))
        );

        ProduitContenu.setBackground(new java.awt.Color(255, 255, 255));

        jToggleButton1.setText("Vanille");
        jToggleButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton1ActionPerformed(evt);
            }
        });

        jToggleButton2.setText("Chocolat");
        jToggleButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton2ActionPerformed(evt);
            }
        });

        jToggleButton3.setText("Chewing Gun");
        jToggleButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton3ActionPerformed(evt);
            }
        });

        jToggleButton4.setText("Coco");
        jToggleButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton4ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout ProduitContenuLayout = new javax.swing.GroupLayout(ProduitContenu);
        ProduitContenu.setLayout(ProduitContenuLayout);
        ProduitContenuLayout.setHorizontalGroup(
            ProduitContenuLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(ProduitContenuLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jToggleButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jToggleButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jToggleButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jToggleButton4, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        ProduitContenuLayout.setVerticalGroup(
            ProduitContenuLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(ProduitContenuLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(ProduitContenuLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jToggleButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jToggleButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jToggleButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jToggleButton4, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        Boules.setBackground(new java.awt.Color(255, 255, 255));

        jToggleButton7.setText("1 Boule");
        jToggleButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton7ActionPerformed(evt);
            }
        });

        jToggleButton8.setText("2 Boules");
        jToggleButton8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton8ActionPerformed(evt);
            }
        });

        jToggleButton9.setText("3 Boules");
        jToggleButton9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton9ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout BoulesLayout = new javax.swing.GroupLayout(Boules);
        Boules.setLayout(BoulesLayout);
        BoulesLayout.setHorizontalGroup(
            BoulesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(BoulesLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jToggleButton7, javax.swing.GroupLayout.PREFERRED_SIZE, 96, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jToggleButton8, javax.swing.GroupLayout.PREFERRED_SIZE, 96, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jToggleButton9, javax.swing.GroupLayout.PREFERRED_SIZE, 96, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        BoulesLayout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jToggleButton7, jToggleButton8, jToggleButton9});

        BoulesLayout.setVerticalGroup(
            BoulesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(BoulesLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(BoulesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jToggleButton7, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jToggleButton8, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jToggleButton9, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(ListCommande, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(BarSup, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(Numerique, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(Option, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(ProduitContenu, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(Produit, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(Boules, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(BarSup, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(ListCommande, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(1, 1, 1)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(Numerique, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(Option, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(Produit, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(Boules, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(ProduitContenu, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void Produit1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Produit1ActionPerformed
        Boules.setVisible(true);
    }//GEN-LAST:event_Produit1ActionPerformed

    
    private void jButton11ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton11ActionPerformed
        Object o1 = JDBCConnect.produit.get(1);
        Float n1 = Float.valueOf(o1.toString());
        
        nombre+=1;
        int nb = Integer.parseInt(nombre);
        float total = nb * n1;
        jTable1.setValueAt(nb,0,1);
        jTable1.setValueAt(total, 0, 2);
    }//GEN-LAST:event_jButton11ActionPerformed

    private void Produit2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Produit2ActionPerformed
        int n = 1;
        limitIngre = 1;
        ingre = 0;
        nombre = "";
        String sql = "Select * from produit where nom = 'Milk-Shake'";
        try {
            JDBCConnect.ListProduit(sql);
        } catch (Exception e) {
            System.out.println("Erreur "+e);
        }
        
        Object o1 = JDBCConnect.produit.get(1);
        Float n1 = Float.valueOf(o1.toString());
        
        DefaultTableModel model = (DefaultTableModel) jTable1.getModel();
        
        model.addRow(new Object[]{JDBCConnect.produit.get(0), 1, n1});
        
        ProduitContenu.setVisible(true);
    }//GEN-LAST:event_Produit2ActionPerformed

    private void jButton12ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton12ActionPerformed
        Object o1 = JDBCConnect.produit.get(1);
        Float n1 = Float.valueOf(o1.toString());
        
        nombre+=2;
        int nb = Integer.parseInt(nombre);
        float total = nb * n1;
        jTable1.setValueAt(nb,jTable1.getRowCount()-1,1);
        jTable1.setValueAt(total, jTable1.getRowCount()-1, 2);
    }//GEN-LAST:event_jButton12ActionPerformed

    private void jButton14ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton14ActionPerformed
        Object o1 = JDBCConnect.produit.get(1);
        Float n1 = Float.valueOf(o1.toString());
        
        nombre="0";
        int nb = Integer.parseInt(nombre);
        float total = nb * n1;
        jTable1.setValueAt(1,jTable1.getRowCount()-1,1);
        jTable1.setValueAt(1 * n1, jTable1.getRowCount()-1, 2);
    }//GEN-LAST:event_jButton14ActionPerformed

    private void jButton13ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton13ActionPerformed
        Object o1 = JDBCConnect.produit.get(1);
        Float n1 = Float.valueOf(o1.toString());
        
        nombre+=3;
        int nb = Integer.parseInt(nombre);
        float total = nb * n1;
        jTable1.setValueAt(nb,jTable1.getRowCount()-1,1);
        jTable1.setValueAt(total, jTable1.getRowCount()-1, 2);
    }//GEN-LAST:event_jButton13ActionPerformed

    private void jButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton6ActionPerformed
        Object o1 = JDBCConnect.produit.get(1);
        Float n1 = Float.valueOf(o1.toString());
        
        nombre+=4;
        int nb = Integer.parseInt(nombre);
        float total = nb * n1;
        jTable1.setValueAt(nb,jTable1.getRowCount()-1,1);
        jTable1.setValueAt(total, jTable1.getRowCount()-1, 2);
    }//GEN-LAST:event_jButton6ActionPerformed

    private void jButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton7ActionPerformed
        Object o1 = JDBCConnect.produit.get(1);
        Float n1 = Float.valueOf(o1.toString());
        
        nombre+=5;
        int nb = Integer.parseInt(nombre);
        float total = nb * n1;
        jTable1.setValueAt(nb,jTable1.getRowCount()-1,1);
        jTable1.setValueAt(total, jTable1.getRowCount()-1, 2);
    }//GEN-LAST:event_jButton7ActionPerformed

    private void jButton8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton8ActionPerformed
        Object o1 = JDBCConnect.produit.get(1);
        Float n1 = Float.valueOf(o1.toString());
        
        nombre+=6;
        int nb = Integer.parseInt(nombre);
        float total = nb * n1;
        jTable1.setValueAt(nb,jTable1.getRowCount()-1,1);
        jTable1.setValueAt(total, jTable1.getRowCount()-1, 2);
    }//GEN-LAST:event_jButton8ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        Object o1 = JDBCConnect.produit.get(1);
        Float n1 = Float.valueOf(o1.toString());
        
        nombre+=7;
        int nb = Integer.parseInt(nombre);
        float total = nb * n1;
        jTable1.setValueAt(nb,jTable1.getRowCount()-1,1);
        jTable1.setValueAt(total, jTable1.getRowCount()-1, 2);
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        Object o1 = JDBCConnect.produit.get(1);
        Float n1 = Float.valueOf(o1.toString());
        
        nombre+=8;
        int nb = Integer.parseInt(nombre);
        float total = nb * n1;
        jTable1.setValueAt(nb,jTable1.getRowCount()-1,1);
        jTable1.setValueAt(total, jTable1.getRowCount()-1, 2);
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        Object o1 = JDBCConnect.produit.get(1);
        Float n1 = Float.valueOf(o1.toString());
        
        nombre+=9;
        int nb = Integer.parseInt(nombre);
        float total = nb * n1;
        jTable1.setValueAt(nb,jTable1.getRowCount()-1,1);
        jTable1.setValueAt(total, jTable1.getRowCount()-1, 2);
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton17ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton17ActionPerformed
        Object o1 = JDBCConnect.produit.get(1);
        Float n1 = Float.valueOf(o1.toString());
        
        nombre+=0;
        int nb = Integer.parseInt(nombre);
        float total = nb * n1;
        jTable1.setValueAt(nb, jTable1.getRowCount()-1,1);
        jTable1.setValueAt(total, jTable1.getRowCount()-1, 2);
    }//GEN-LAST:event_jButton17ActionPerformed

    private void jToggleButton9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton9ActionPerformed
        int n = 1;
        nombre = "";
        limitIngre = 3;
        ingre = 0;
        String sql = "Select * from produit where nom = '3 Boules'";
        try {
            JDBCConnect.ListProduit(sql);
        } catch (Exception e) {
            System.out.println("Erreur "+e);
        }
        
        Object o1 = JDBCConnect.produit.get(1);
        Float n1 = Float.valueOf(o1.toString());
        
        DefaultTableModel model = (DefaultTableModel) jTable1.getModel();
        
        model.addRow(new Object[]{JDBCConnect.produit.get(0), 1, n1});
        
        ProduitContenu.setVisible(true);
    }//GEN-LAST:event_jToggleButton9ActionPerformed

    private void jToggleButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton7ActionPerformed
        int n = 1;
        nombre = "";
        limitIngre = 1;
        ingre = 0;
        String sql = "Select * from produit where nom = '1 Boule'";
        try {
            JDBCConnect.ListProduit(sql);
        } catch (Exception e) {
            System.out.println("Erreur "+e);
        }
        
        Object o1 = JDBCConnect.produit.get(1);
        Float n1 = Float.valueOf(o1.toString());
        
        DefaultTableModel model = (DefaultTableModel) jTable1.getModel();
        
        model.addRow(new Object[]{JDBCConnect.produit.get(0), 1, n1});
        
        ProduitContenu.setVisible(true);
    }//GEN-LAST:event_jToggleButton7ActionPerformed

    private void jToggleButton8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton8ActionPerformed
        int n = 1;
        nombre = "";
        limitIngre = 2;
        ingre = 0;
        String sql = "Select * from produit where nom = '2 Boules'";
        try {
            JDBCConnect.ListProduit(sql);
        } catch (Exception e) {
            System.out.println("Erreur "+e);
        }
        
        Object o1 = JDBCConnect.produit.get(1);
        Float n1 = Float.valueOf(o1.toString());
        
        DefaultTableModel model = (DefaultTableModel) jTable1.getModel();
        
        model.addRow(new Object[]{JDBCConnect.produit.get(0), 1, n1});
        
        ProduitContenu.setVisible(true);
    }//GEN-LAST:event_jToggleButton8ActionPerformed

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        DefaultTableModel model = (DefaultTableModel) jTable1.getModel();
        int n = jTable1.getRowCount();
        for(int i = n-1; i>=0; i--){
            model.removeRow(i);
        }
    }//GEN-LAST:event_jButton4ActionPerformed

    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
        String name = "";
        float prix = 0.0f;
        
        for(int i = 0; i<jTable1.getRowCount(); i++){
            name += (String)jTable1.getValueAt(i, 0) + ", ";
        }
        for(int i = 0; i<jTable1.getRowCount(); i++){
            prix += (float)jTable1.getValueAt(i, 2);
        }
        
        String sql = "insert Into commande (nom,prix) values ('"+name+"','"+prix+"')";
        
        try {
            JDBCConnect.ValideCommande(sql);
        } catch (Exception e) {
            System.out.println("Erreur "+e);
        }
    }//GEN-LAST:event_jButton5ActionPerformed
    
    private void jToggleButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton4ActionPerformed
        if(ingre < limitIngre){
            int n = 1;
            nombre = "";
            String sql = "Select * from ingredient where nom = 'Coco'";
            try {
                JDBCConnect.ListIngredient(sql);
            } catch (Exception e) {
                System.out.println("Erreur "+e);
            }

            if(jToggleButton4.isSelected()){
                jTable1.setValueAt(jTable1.getValueAt(jTable1.getRowCount()-1, 0) +" " + JDBCConnect.ingredient.get(0), jTable1.getRowCount()-1, 0);
                ingre++;
            }
        }
        if (!jToggleButton4.isSelected()){
            String chaine = (String)jTable1.getValueAt(jTable1.getRowCount()-1, 0);
            jTable1.setValueAt(chaine.replaceAll(" Coco", ""), jTable1.getRowCount()-1, 0);
            ingre--;
        }
        
        if(ingre < 0){
            ingre = 0;
        }
    }//GEN-LAST:event_jToggleButton4ActionPerformed

    private void jToggleButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton3ActionPerformed
        if(ingre < limitIngre){
            int n = 1;
            nombre = "";
            String sql = "Select * from ingredient where nom = 'Chewing Gum'";
            try {
                JDBCConnect.ListIngredient(sql);
            } catch (Exception e) {
                System.out.println("Erreur "+e);
            }

            if(jToggleButton3.isSelected()){
                jTable1.setValueAt(jTable1.getValueAt(jTable1.getRowCount()-1, 0) +" " + JDBCConnect.ingredient.get(0), jTable1.getRowCount()-1, 0);
                ingre++;
            }
        }
        if(!jToggleButton3.isSelected()){
            String chaine = (String)jTable1.getValueAt(jTable1.getRowCount()-1, 0);
            jTable1.setValueAt(chaine.replaceAll(" Chewing Gum", ""), jTable1.getRowCount()-1, 0);
            ingre--;
        }
        
        if(ingre < 0){
            ingre = 0;
        }
    }//GEN-LAST:event_jToggleButton3ActionPerformed

    private void jToggleButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton2ActionPerformed
        if(ingre < limitIngre){
            int n = 1;
            nombre = "";
            String sql = "Select * from ingredient where nom = 'Chocolat'";
            try {
                JDBCConnect.ListIngredient(sql);
            } catch (Exception e) {
                System.out.println("Erreur "+e);
            }

            if(jToggleButton2.isSelected()){
                jTable1.setValueAt(jTable1.getValueAt(jTable1.getRowCount()-1, 0) +" " + JDBCConnect.ingredient.get(0), jTable1.getRowCount()-1, 0);
                ingre++;
            }
        }
        if (!jToggleButton2.isSelected()){
            String chaine = (String)jTable1.getValueAt(jTable1.getRowCount()-1, 0);
            jTable1.setValueAt(chaine.replaceAll(" Chocolat", ""), jTable1.getRowCount()-1, 0);
            ingre--;
        }
        
        if(ingre < 0){
            ingre = 0;
        }
    }//GEN-LAST:event_jToggleButton2ActionPerformed

    private void jToggleButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton1ActionPerformed
        if(ingre < limitIngre){
            int n = 1;
            nombre = "";
            String sql = "Select * from ingredient where nom = 'Vanille'";
            try {
                JDBCConnect.ListIngredient(sql);
            } catch (Exception e) {
                System.out.println("Erreur "+e);
            }

            if(jToggleButton1.isSelected()){
                jTable1.setValueAt(jTable1.getValueAt(jTable1.getRowCount()-1, 0) +" " + JDBCConnect.ingredient.get(0), jTable1.getRowCount()-1, 0);
                ingre++;
            }
        }
        if (!jToggleButton1.isSelected()){
            String chaine = (String)jTable1.getValueAt(jTable1.getRowCount()-1, 0);
            jTable1.setValueAt(chaine.replaceAll(" Vanille", ""), jTable1.getRowCount()-1, 0);
            ingre--;
        }
        
        if(ingre < 0){
            ingre = 0;
        }
    }//GEN-LAST:event_jToggleButton1ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) throws Exception{
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Caisse.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Caisse.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Caisse.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Caisse.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold> 
        
        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Caisse().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel BarSup;
    private javax.swing.JPanel Boules;
    private javax.swing.JPanel ListCommande;
    private javax.swing.JPanel Numerique;
    private javax.swing.JPanel Option;
    private javax.swing.JPanel Produit;
    private javax.swing.JButton Produit1;
    private javax.swing.JButton Produit2;
    private javax.swing.JPanel ProduitContenu;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton11;
    private javax.swing.JButton jButton12;
    private javax.swing.JButton jButton13;
    private javax.swing.JButton jButton14;
    private javax.swing.JButton jButton17;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JButton jButton7;
    private javax.swing.JButton jButton8;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JToggleButton jToggleButton1;
    private javax.swing.JToggleButton jToggleButton2;
    private javax.swing.JToggleButton jToggleButton3;
    private javax.swing.JToggleButton jToggleButton4;
    private javax.swing.JToggleButton jToggleButton7;
    private javax.swing.JToggleButton jToggleButton8;
    private javax.swing.JToggleButton jToggleButton9;
    private javax.swing.JLabel txt_date;
    // End of variables declaration//GEN-END:variables
}
